﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
Das ServerObjekt implementiert und instanziert auffm Server die IServerObject-Schnittstelle. Clients können es über den Remoting-Channel abrufen - dann stehen ihnen die Methoden der Schnittstelle: HandShake und Message zur Verfügung.
Die Methoden lösen im GuiThread je ein Event aus, was die Argumente nur durchreicht.
Durch die Thread-Verlagerung können bei der Datenverarbeitung im eiglichen Server keinerlei Threading-Probleme entstehen.
#End If
' -------------- Imports & Options --------------------
Imports Common
#End Region 'FileHeader

Public Class ServerObject : Inherits ServerBase : Implements IServerObject

   Public Event MessageIn As Action(Of Integer, String)
   Public Event HandShakeIn(nick As String, callbackHandshakeSuccess As Action(Of Integer?), callbackMessage As Action(Of String), callbackMoveForm As Action(Of Integer))

   Private Sub HandShake(nick As String, callBackHandshake As Action(Of Integer?), callBackMessage As Action(Of String), callBackMoveForm As Action(Of Integer)) Implements IServerObject.HandShake
      CrossThreadX.RunGui(Sub() RaiseEvent HandShakeIn(nick, callBackHandshake, callBackMessage, callBackMoveForm))
   End Sub

   Private Sub Message(id As Integer, msg As String) Implements IServerObject.Message
      CrossThreadX.RunGui(Sub() RaiseEvent MessageIn(id, msg))
   End Sub
End Class
