﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
die beim Handshake dem Server Übergebenen Callbacks müssen auf **Public** Subs verweisen!!
Auch hier wird jeder einkommende Aufruf direkt in den Gui-Thread umgeleitet
Senden hingegen asynchron, damit eine langsame Verbindung nicht das Gui blockiert
#End If
' -------------- Imports & Options --------------------
Imports Common
#End Region 'FileHeader

Public Class frmClient
   Private _ProxyMaker As ProxyFactory
   Private _ServerObject As IServerObject
   Private _ID As Integer = 0

   Private Sub ckOnline_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles ckOnline.CheckedChanged
      If ckOnline.Checked Then
         _ProxyMaker = New ProxyFactory
         _ServerObject = _ProxyMaker.GetProxy
         _ServerObject.HandShake(txtNick.Text, AddressOf HandshakeIn, AddressOf MessageIn, AddressOf MoveFormIn)
      Else
         _ProxyMaker.Dispose()
      End If
   End Sub

   Private Sub btSend_Click(sender As System.Object, e As System.EventArgs) Handles btSend.Click
      CrossThreadX.RunAsync(AddressOf _ServerObject.Message, _ID, txtToSend.Text)
   End Sub

#Region "Callback-Targets"
   Public Sub HandshakeIn(allocedId As Integer?)
      CrossThreadX.RunGui(Sub()
                             txtLog.AppendLine("Handshake accepted:", allocedId.HasValue)
                             If allocedId.HasValue Then
                                _ID = allocedId.Value
                             Else
                                ckOnline.Checked = False
                             End If
                          End Sub)
   End Sub
   Public Sub MessageIn(msg As String)
      CrossThreadX.RunGui(AddressOf txtLog.AppendLine, msg)
   End Sub
   Public Sub MoveFormIn(value As Integer)
      CrossThreadX.RunGui(Sub() Me.Top += value)
   End Sub
#End Region 'Callback-Targets

End Class
